// Generated by CoffeeScript 1.10.0
var dictApp;

dictApp = angular.module('fairyDictApp', ['ui.bootstrap', 'ngSanitize']);

dictApp.run(function($rootScope) {
  return $rootScope._ = _;
});

loader.loadTemplate().then(function() {
  return angular.bootstrap(document.getElementById('fairy-dict'), ['fairyDictApp']);
});

dictApp.controller('dictCtrl', function($scope, $sce) {
  var _handler, applyHistory, baseNode, ref, updateRating;
  console.log("[dictCtrl] init");
  document.title = 'Fairy Dict';
  baseNode = '#fairy-dict';
  $scope.initial = true;
  $scope.querying = false;
  $scope.queryResult = null;
  $scope.historyIndex = -1;
  chrome.runtime.sendMessage({
    type: 'dictionary'
  }, function(arg) {
    var allDicts, dictionary, history;
    dictionary = arg.dictionary, allDicts = arg.allDicts, history = arg.history;
    console.log("[dict] all dicts: ", allDicts);
    $scope.allDicts = allDicts;
    $scope.currentDictionary = allDicts.find(function(d) {
      return d.dictName === dictionary;
    });
    if ($scope.currentDictionary == null) {
      $scope.currentDictionary = allDicts[0];
    }
    $scope.history = history.reverse();
    $scope.lastHistoryWord = $scope.history[0];
    return $scope.$apply();
  });
  chrome.runtime.sendMessage({
    type: 'setting'
  }, function(setting) {
    return $scope.setting = setting;
  });
  $scope.changeDict = function(dict) {
    var ci, idx;
    ci = $scope.allDicts.findIndex(function(d) {
      return d.dictName === $scope.currentDictionary.dictName;
    });
    if (dict === 'next') {
      idx = (ci + 1) % $scope.allDicts.length;
      $scope.currentDictionary = $scope.allDicts[idx];
    } else if (dict === 'prev') {
      idx = ci > 0 ? ci - 1 : $scope.allDicts.length - 1;
      $scope.currentDictionary = $scope.allDicts[idx];
    } else {
      $scope.currentDictionary = dict;
    }
    return $scope.query(true);
  };
  applyHistory = function(index) {
    $scope.historyIndex = index;
    if (index > -1) {
      $scope.word = _.keys($scope.history[index])[0];
    } else {
      $scope.word = $scope.lastQueryWord;
    }
    if (index === $scope.history.length - 1) {
      return $scope.lastHistoryWord = $scope.history[0];
    } else {
      return $scope.lastHistoryWord = $scope.history[index + 1];
    }
  };
  $scope.selectHistory = function(index) {
    if (index === $scope.historyIndex) {
      return;
    }
    if (index === 'prev') {
      if ($scope.historyIndex === $scope.history.length - 1) {
        return;
      }
      index = $scope.historyIndex + 1;
    } else if (index === 'next') {
      if ($scope.historyIndex < 0) {
        return;
      }
      index = $scope.historyIndex - 1;
    }
    if (index >= $scope.history.length) {
      index = 0;
    }
    applyHistory(index);
    return $scope.query(true);
  };
  $scope.deleteHistory = function(index) {
    var item;
    item = $scope.history.splice(index, 1);
    chrome.runtime.sendMessage({
      type: 'deleteHistory',
      index: index,
      text: _.keys(item[0])[0]
    });
    return false;
  };
  $scope.query = function(inHistory) {
    if (!$scope.word || !$scope.currentDictionary) {
      $scope.initial = true;
      return;
    }
    console.log("[dictCtrl] query `" + $scope.word + "` from " + $scope.currentDictionary.dictName);
    $scope.initial = false;
    $scope.querying = true;
    return chrome.runtime.sendMessage({
      type: 'query',
      text: $scope.word,
      dictionary: $scope.currentDictionary.dictName,
      inHistory: inHistory
    });
  };
  if ((ref = chrome.runtime.onMessage) != null) {
    ref.addListener(function(request, sender, sendResponse) {
      var ref1;
      if (request.type === 'querying') {
        $scope.initial = false;
        $scope.querying = true;
        $scope.queryResult = null;
        $scope.word = request.text;
      } else if (request.type === 'queryResult') {
        console.log("[dictCtrl] got query result for word: " + request.text);
        if ($scope.word === request.text || !$scope.word) {
          $scope.initial = false;
          $scope.word = request.text;
          $scope.querying = false;
          if (((ref1 = request.result) != null ? ref1.html : void 0) != null) {
            $scope.queryResult = $sce.trustAsHtml(request.result.html);
          }
          $scope.rating = request.rating;
          updateRating(request.rating);
          if (!request.inHistory) {
            $scope.lastQueryWord = $scope.word;
          } else {
            $scope.history.forEach(function(item, idx) {
              var itemText;
              itemText = _.keys(item)[0];
              if (itemText === $scope.word) {
                return applyHistory(idx);
              }
            });
          }
        }
      } else if (request.type === 'history') {
        console.log("history", request.history);
        $scope.history = request.history.reverse();
        $scope.lastHistoryWord = $scope.history[0];
        $scope.historyIndex = -1;
      }
      return $scope.$apply();
    });
  }
  $('#fairy-stars', baseNode).on('starrr:change', function(e, value) {
    var item;
    if ($scope.word) {
      if (value == null) {
        value = 0;
      }
      console.log("[dictCtrl] rating word: " + $scope.word + " " + value);
      chrome.runtime.sendMessage({
        type: 'rating',
        value: value,
        text: $scope.word
      });
      if ($scope.historyIndex >= 0) {
        item = $scope.history[$scope.historyIndex];
        if (item && (item[$scope.word] != null)) {
          return item[$scope.word] = value;
        }
      }
    }
  });
  $('.starrr', baseNode).starrr({
    numStars: 3
  });
  updateRating = function(value) {
    var obj;
    obj = $(".starrr", baseNode).data('star-rating');
    obj.options.rating = value;
    return obj.syncRating();
  };
  _handler = function(evt) {
    var a, node;
    node = $(event.target);
    if (node.is('.sound')) {
      a = node.next('audio');
      if (a.length) {
        return a[0].play();
      }
    }
  };
  $(document).mouseover(_handler);
  $(document).click(_handler);
  $(document).keyup(function(evt) {
    var code;
    code = evt.charCode || evt.keyCode;
    if (code === 27) {
      return $('input.dict-input', baseNode)[0].select();
    }
  });
  $(document).keydown(function(evt) {
    var code, nextKey, nextSK, prevKey, prevSK, stop;
    code = evt.charCode || evt.keyCode;
    prevSK = $scope.setting.prevDictSK1;
    nextSK = $scope.setting.nextDictSK1;
    prevKey = $scope.setting.prevDictKey;
    nextKey = $scope.setting.nextDictKey;
    stop = false;
    if (window.utils.checkEventKey(evt, prevSK, null, prevKey)) {
      $scope.changeDict('prev');
      stop = true;
    }
    if (window.utils.checkEventKey(evt, nextSK, null, nextKey)) {
      $scope.changeDict('next');
      stop = true;
    }
    if (window.utils.checkEventKey(evt, $scope.setting.prevHistorySK1, null, $scope.setting.prevHistoryKey)) {
      $scope.selectHistory('prev');
      stop = true;
    }
    if (window.utils.checkEventKey(evt, $scope.setting.nextHistorySK1, null, $scope.setting.nextHistoryKey)) {
      $scope.selectHistory('next');
      stop = true;
    }
    if (stop) {
      evt.preventDefault();
      return evt.stopPropagation();
    }
  });
});
